//==================================================
//POV-Ray Materials list
//==================================================
//This file has been created by PoseRay v3.13.29.645
//3D model to POV-Ray/Moray Converter.
//Author: FlyerX
//Email: flyerx_2000@yahoo.com
//Web: https://sites.google.com/site/poseray/
//==================================================
//Files needed to run the POV-Ray scene:
//Kameri_explorer_landed_POV_main.ini (initialization file - open this to render)
//Kameri_explorer_landed_POV_scene.pov (scene setup of cameras, lights and geometry)
//KameriLandedGeom.inc (geometry)
//KameriLandedMat.inc (materials)
//cp2.jpg
//cna1.jpg
//dcvx1d.jpg
//dgtd2.jpg
//dcvx1.jpg
//ggt1.jpg

//==================================================
//Map definitions
#declare P_map1 = pigment{ image_map{ jpeg concat(ModelsSubDir, "kameriLandedMaps/cp2.jpg") transmit all 0 } }
#declare P_map2 = pigment{ image_map{ jpeg concat(ModelsSubDir, "kameriLandedMaps/cna1.jpg") transmit all 0 } }
#declare P_map3 = pigment{ image_map{ jpeg concat(ModelsSubDir, "kameriLandedMaps/dcvx1d.jpg") transmit all 0 } }
#declare P_map4 = pigment{ image_map{ jpeg concat(ModelsSubDir, "kameriLandedMaps/dgtd2.jpg") transmit all 0 } }
#declare P_map5 = pigment{ image_map{ jpeg concat(ModelsSubDir, "kameriLandedMaps/dcvx1.jpg") transmit all 0 } }
#declare P_map6 = pigment{ image_map{ jpeg concat(ModelsSubDir, "kameriLandedMaps/ggt1.jpg") transmit all 0 } }
 
//==================================================
//Material definitions
#declare DefaultSpecular = 0.3;
#declare DefaultRoughness = 0.01;

#declare DefaultPig = pigment{ P_map1 }

#declare DefaultFinish = 
finish{ 
	specular  DefaultSpecular 
	roughness DefaultRoughness
	phong 0 phong_size 0 
}

#declare DefaultTexture = texture{ pigment{uv_mapping DefaultPig } finish{ DefaultFinish } }

#declare DefaultCushionPigment = pigment{ P_map2 }

#declare DefaultCushionFinish = 
finish{
	specular  DefaultSpecular 
	roughness DefaultRoughness
	phong 0 phong_size 0
}

#declare DefaultCushionTexture = 
texture{
	pigment{uv_mapping DefaultCushionPigment }
	finish{ DefaultCushionFinish }
}

#declare DefaultBody1bPigment = pigment {color srgb < 0, 0, 0 > transmit 20/100 }

#declare DefaultBody1bFinish = 
finish{
	specular  DefaultSpecular 
	roughness DefaultRoughness
	phong 0 phong_size 0
}

#declare DefaultBody1bTexture = 
texture{
	pigment{uv_mapping DefaultBody1bPigment }
	finish{ DefaultBody1bFinish }
}

#declare DefaultBody1Pigment = pigment{ P_map1 }

#declare DefaultBody1Finish =
finish{
	specular  DefaultSpecular
	roughness DefaultRoughness
	phong 0 phong_size 0
}


#declare DefaultBody1Texture =
texture{
	pigment{ uv_mapping DefaultBody1Pigment }
	finish{ DefaultBody1Finish }
}

#declare DefaultFirePigment = pigment {color srgb <0.00,1.00,1.00> transmit 0/100 }


#declare DefaultFireFinish = 
finish{
	specular  DefaultSpecular
	roughness DefaultRoughness
	phong 0 phong_size 0
}

#declare DefaultFireTexture = 
texture{
	pigment{uv_mapping DefaultFirePigment }
	finish{ DefaultFireFinish }
}

#declare DefaultRedLightPigment = pigment{color srgb <1.00,0.00,0.00> transmit 0/100 }

#declare DefaultRedLightFinish =
finish{specular  DefaultSpecular
	roughness DefaultRoughness
	phong 0 phong_size 0
}

#declare DefaultRedLightTexture = 
texture{
	pigment{uv_mapping DefaultRedLightPigment }
	finish{ DefaultRedLightFinish }
}

#declare DefaultLightPigment = pigment {color srgb <1.00,1.00,1.00> transmit 0/100 }

#declare DefaultLightFinish = finish{
	specular  DefaultSpecular 
	roughness DefaultRoughness
	phong 0 phong_size 0
}

#declare DefaultLightTexture = 
texture{
	pigment{ uv_mapping DefaultLightPigment }
	finish{ DefaultLightFinish }
}

#declare DefaultSkinPigment = pigment{ P_map3 }

#declare DefaultSkinFinish = 
finish{
	specular  DefaultSpecular 
	roughness DefaultRoughness
}

#declare DefaultSkinTexture = 
texture{
	pigment{uv_mapping DefaultSkinPigment }
	finish{ DefaultSkinFinish }
}

#declare DefaultShipPigment = pigment{ P_map4 }

#declare DefaultShipFinish =
finish{
	specular  DefaultSpecular 
	roughness DefaultRoughness
	phong 0 phong_size 0
}

#declare DefaultShipTexture = 
texture{
	pigment{ uv_mapping DefaultShipPigment }
	finish{ DefaultShipFinish }
}

#declare DefaultGatePigment = pigment{ P_map5 }

#declare DefaultGateFinish =
finish{
	specular DefaultSpecular 
	roughness DefaultRoughness
	phong 0 phong_size 0
}

#declare DefaultGateTexture = 
texture{
	pigment{ uv_mapping DefaultGatePigment }
	finish{ DefaultGateFinish }
}

#declare DefaultJoystickPigment = pigment{ color srgb <0.00,0.00,0.00> transmit 0/100 }

#declare DefaultJoystickFinish = 
finish{
	specular  DefaultSpecular 
	roughness DefaultRoughness
	phong 0 phong_size 0
}

#declare DefaultJoystickTexture = 
texture{
	pigment{uv_mapping DefaultJoystickPigment }
	finish{ DefaultJoystickFinish }
}

#declare DefaultCockpit1DisplayPigment = pigment{ P_map6 }

#declare DefaultCockpit1DisplayFinish =
finish{
	specular DefaultSpecular
	roughness DefaultRoughness
	phong 0 phong_size 0
}

#declare DefaultCockpit1DisplayTexture =
texture {
	pigment{uv_mapping DefaultCockpit1DisplayPigment }
	finish{ DefaultCockpit1DisplayFinish }
}

#declare DefaultCockpit2Pigment = pigment{ P_map1 }

#declare DefaultCockpit2Finish =
finish{
	specular  DefaultSpecular
	roughness DefaultRoughness
	phong 0 phong_size 0
}

#declare DefaultCockpit2Texture = 
texture{
	pigment{uv_mapping DefaultCockpit2Pigment }
	finish{ DefaultCockpit2Finish }
}

#declare DefaultRampPigment = pigment{ P_map4 }

#declare DefaultRampFinish =
finish{
	specular DefaultSpecular
	roughness DefaultRoughness
	phong 0 phong_size 0
}

#declare DefaultRampTexture =
texture{
	pigment{uv_mapping DefaultRampPigment }
	finish{ DefaultRampFinish }
}
